#-*- coding: Utf-8 -*-


#Compositions d'exponentiations

def expoexpo_iter(a, n):
    if n < 0:
        return None
    if n == 0:
        return 1
    puissance = a
    for k in range(1, n+1):
        puissance = puissance**a
    return puissance


def expoexpo_rec(a, n):
    if n < 0:
        return None
    if n == 0:
        return 1
    if n == 1:
        return a
    return (expoexpo_rec(a, n-1))**a
   
    
"""
#Question : pourquoi ne faut-il pas donner la meme valeur à #l'exposant k pour obtenir le meme résultat pour les 2 fonctions ?
In [72]: [(expoexpo_iter(2, k), expoexpo_rec(2, k+1)) for k in range(5)]
Out[72]: [(1, 2), (4, 4), (16, 16), (256, 256), (65536, 65536)]

"""