#-*- coding: Utf-8 -*

def supn(liste,n):
    """retourne le nombre d'éléments supérieurs à n dans une liste"""
    compteur = 0
    for i in range(len(liste)):
        if liste[i]>n:
            compteur+=1
    return compteur
    

def nb_voyelles(chaine):
    """retourne le nombre de voyelles dans une chaine
    de caractères """
    compteur = 0 
    voyelles = ['a','o','e','i','u','y']
    for c in chaine:
        if c in voyelles:
            compteur+=1
    return compteur
    

def tab_voyelles(chaine):
    """retourne la répartitition des voyelles dans une chaine
    sous la forme d'un dictionnaie (sorte de tableau d'effectifs"""
    tab ={'e':0,'a':0,'o':0,'e':0,'i':0,'u':0,'y':0}
    for i in tab.keys():
        if i in chaine:
            tab[i]+=1
    return tab

def tri_pair(liste):
    """prend en entrée une liste d'entiers et retourne
    une autre liste avec les entiers pairs à gauche et les impairs à droite"""
    l = []
    for i in range(len(liste)):
        if liste[i]%2==0:
            l.insert(0,l[i]) #si pair on insère au début
        else:
            l.insert(len(l)-1,l[i]) #sinon on insère à la fin
    return l
    

def tri_pair2(liste):
    """prend en entrée une liste d'entiers et retourne
    une autre liste avec les entiers pairs à gauche et les impairs à droite"""
    lpair = []
    limpair = []
    for i in range(len(liste)):
        if liste[i]%2==0:
            lpair.append(liste[i]) #on insère l'élément dans la liste des pairs
        else:
            limpair.append(liste[i])  #sinon on l'insèredans la liste des impairs
    return lpair+limpair #on concatène les listes d'entiers pairs et impairs    
    
def tri_pairbulles(liste):
    """prend en entrée une liste d'entiers et réordonne sur place
    cette liste avec les entiers pairs à gauche et les impairs à droite 
    avec un algorithme de type tri par bulles où la liste est parcourue de gauche à droite 
    en poussnat les entiers pairs vers la gauche tant qu'il y a un entier pair à droite d'un entier impair"""
    tri = False
    while not tri:
        for i in range(len(liste)):
            tri = True
            if (liste[i]%2!=0)  and (liste[i+1]%2==0): #si un impair est à gauche d'un pair
                #on échange les places des entiers impair et pair successifs
                stock = liste[i]
                liste[i] = liste[i+1]
                liste[i+1] = stock
                tri = False
    return liste
        
            
            
                        
                
    
    
    
if __name__ == "__main__":
    liste = eval(input('Entrez une liste d\'entiers : \n'))
    n = int(input('Entrez un entier n : \n'))
    print('nombre d\'entiers supérieurs à %d dans la liste :'%n,supn(liste,n))
    chaine = input('Entrez une chaine de caractères')
    print('Nombre de voyelles dans %s'%chaine,nb_voyelles(chaine))
    print('Dictionnaire voyelles dans %s \n :'%chaine,tab_voyelles(chaine))
    
