#-*- coding: Utf-8 -*

from random import randint

def tri_pair(liste):
    """prend en entrée une liste d'entiers et retourne
    une autre liste avec les entiers pairs à gauche et les impairs à droite"""
    l = []
    for i in range(len(liste)):
        if liste[i]%2==0:
            l.insert(0,liste[i]) #si pair on insère au début
        else:
            l.insert(-1,liste[i]) #sinon on insère à la fin
    return l
    

def tri_pair2(liste):
    """prend en entrée une liste d'entiers et retourne
    une autre liste avec les entiers pairs à gauche et les impairs à droite"""
    lpair = []
    limpair = []
    for i in range(len(liste)):
        if liste[i]%2==0:
            lpair.append(liste[i]) #on insère l'élément dans la liste des pairs
        else:
            limpair.append(liste[i])  #sinon on l'insèredans la liste des impairs
    return lpair+limpair #on concatène les listes d'entiers pairs et impairs    
    
    
def tri_pairbulles(liste):
    """prend en entrée une liste d'entiers et réordonne sur place
    cette liste avec les entiers pairs à gauche et les impairs à droite 
    avec un algorithme de type tri par bulles où la liste est parcourue de gauche à droite 
    en poussnat les entiers pairs vers la gauche tant qu'il y a un entier pair à droite d'un entier impair"""
    tri = False
    while not tri:
        tri = True
        for i in range(len(liste)-1):
            if ((liste[i]%2)!=0)    and ((liste[i+1]%2)==0): #si un impair est à gauche d'un pair
                #on échange les places des entiers impair et pair successifs
                stock = liste[i]
                liste[i] = liste[i+1]
                liste[i+1] = stock
                tri = False
    return liste
    


if __name__ == "__main__":
    taille = int(input('Entrez une taille de liste : \n'))
    liste = [randint(1,101) for i in range(taille)]
    print(liste,id(liste))
    L1= tri_pair(liste)
    print(L1,id(L1))
    L2= tri_pair2(liste)
    print(L2,id(L2))
    L3= tri_pairbulles(liste)
    print(L3,id(L3))
