def f1():
    """
    Les variables assignées (ou affectées) dans la fonction
    apartiennent à son espace de nommage local, elles sont 
    invisibles depuis l'espace global.
    Par défaut, les variables globales sont accessibles depuis
    l'espace local en lecture seule.
    Si une variable est affectée, elle est considérée
    comme appartenant à l'espace de nommage local,
    meme si une variable de meme nom existe dans l'espace global
    """
    b = 1 + a
    a = 3
  

def f3():
    """
    Une variable globale  peut etre accessible en écriture avec
    le mot clef global, on peut ainsi modifier une variable 
    globale depuis l'espace local (effet de bord, déconseillé)
    """
    global a
    a = a + 1

def f3():
    """
    Provoque une erreur car la variable a est affectée et global a
    n'est pas utilisé donc le nom a appartient à l'espace local.
    Comme le nom a est référencé avant d'etre assigné celà provo-
    que une erreur
    """
    a = a + 1
    
#Programme principal, espace de nommage global
a = 2
f1()
f2()
f3()def f1():
    """
    Les variables assignées (ou affectées) dans la fonction
    apartiennent à son espace de nommage local, elles sont 
    invisibles depuis l'espace global.
    Par défaut, les variables globales sont accessibles depuis
    l'espace local en lecture seule.
    """
    b = a
    

def f2():
    """
    Si une variable est affectée, elle est considérée
    comme appartenant à l'espace de nommage local,
    meme si une variable de meme nom existe dans l'espace global
    """
    a = 3

def f3():
    """
    Une variable globale  peut etre accessible en écriture avec
    le mot clef global, on peut ainsi modifier une variable 
    globale depuis l'espace local (effet de bord, déconseillé)
    """
    global a
    a = a + 12

def f4():
    """
    Provoque une erreur car la variable a est affectée et global a
    n'est pas utilisé donc le nom a appartient à l'espace local.
    Comme le nom a est référencé avant d'etre assigné celà provo-
    que une erreur
    """
    a = a + 1
    
#Programme principal, espace de nommage global
a = 2
f1()
f2()
f3()
f4()

